#ifndef  __INCLUDES_H
#define  __INCLUDES_H

#ifdef __cplusplus
extern "C" {
#endif

/*********************************************************************************************************
    Wwb_
*********************************************************************************************************/
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>

/*********************************************************************************************************
    hCowb_
*********************************************************************************************************/
#include "inc/hw_types.h"
#include "inc/hw_memmap.h"
#include "inc/hw_ints.h"
#include "inc/hw_gpio.h"
#include "inc/hw_pwm.h"
#include "driverlib/sysctl.h"
#include "driverlib/systick.h"
#include "driverlib/debug.h"
#include "driverlib/gpio.h"
#include "driverlib/interrupt.h"
#include "driverlib/uart.h"
#include "driverlib/pwm.h"
#include "driverlib/qei.h"
#include "driverlib/timer.h"
#include "driverlib/adc.h"
#include "driverlib/ethernet.h"

/*********************************************************************************************************
    f[^^Cv
*********************************************************************************************************/
typedef unsigned char   uint8;
typedef signed   char   int8;
typedef unsigned short  uint16;
typedef signed   short  int16;
typedef unsigned int    uint32;
typedef signed   int    int32;
typedef float           fp32;
typedef double          fp64;

#ifndef TRUE
    #define TRUE  1
#endif

#ifndef FALSE
    #define FALSE 0
#endif

#ifndef NULL
    #define NULL  0
#endif

/*********************************************************************************************************
    |[gwb_
*********************************************************************************************************/
#include <os_cpu.h>
#include <os_cfg.h>
#include <ucos_ii.h>
#include "..\Target\Target.h"
#include "../TCPIP/include/cfg_net.h"

/*********************************************************************************************************
    [Uwb_
*********************************************************************************************************/
#include <Main.h>

#ifdef __cplusplus
}
#endif

#endif

/*********************************************************************************************************
  END FILE 
*********************************************************************************************************/
