#ifdef ICMP_GLOBALS
	#define ICMP_EXT
#else
	#define ICMP_EXT extern
#endif

typedef struct
{
	uint8 type;
	uint8 option;
	uint16 Crc;
	uint16 id;
	uint16 seq;
	uint8 icmpdata[32];
}icmp;

EX_RAM union icmp_rc
{
	icmp e_icmp;
	struct
	{
		uint16 wordbuf[20];
	}words;
};

typedef struct
{
	union ip_rc ipf;
	union icmp_rc icmpf;
}icmppro;

ICMP_EXT EX_RAM union icmp_rc IcmpPacked;

ICMP_EXT uint16  CreateIcmpCrc(union icmp_rc) ;
ICMP_EXT uint8 send_icmp_packed( uint8  * ICMPSENDPTR);
ICMP_EXT void icmp_process(uint8  * ICMPSENDPTR,uint8 num) ;
ICMP_EXT void Ping_Precess(uint8 * de_ip,uint8 * so_ip);
ICMP_EXT void Icmp_Send(uint8 type,uint8 option,uint8 *so_ip,uint8 *de_ip, uint8 * REC_FRAME );
