#include "..\User\includes.h"

/********************************************************************************************
    USER TASK PRIORITIES
********************************************************************************************/
#define TASK_START_PRIO     0
#define TASK_LED_PRIO       15
#define TASK_OLED_PRIO      6
#define TASK_HTTP_PRIO      7
#define TASK_FatFs_PRIO     8
#define TASK_DotMatrix_PRIO 9

/********************************************************************************************
    USER TASK STACK SIZES
********************************************************************************************/
#define TASK_Startup_STACK    500
#define TASK_LED_STACK        500
#define TASK_OLED_STACK       500
#define TASK_HTTP_STACK       500
#define TASK_FatFs_STACK      500
#define TASK_DotMatrix_STACK  500

/********************************************************************************************
    USER TASK STACK
********************************************************************************************/
OS_STK TASK_Startup_stack[TASK_Startup_STACK];
OS_STK TASK_LED_stack[TASK_LED_STACK];
OS_STK TASK_OLED_stack[TASK_OLED_STACK];
OS_STK TASK_HTTP_stack[TASK_HTTP_STACK];
OS_STK TASK_FatFs_stack[TASK_FatFs_STACK];
OS_STK TASK_DotMatrix_stack[TASK_DotMatrix_STACK];

/********************************************************************************************
    USER TASK
********************************************************************************************/
/********************************************************************************************
    hbg}gNXLED_Ci~bN_^XN
********************************************************************************************/
char character = 'A';  // \ؑ֗pO[oϐ

void Task_DotMatrix(void *pdata)
{
    int i = 0;  // ėpJE^
    
    // gp|[g̐錾 
    SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOB);
    SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOC);
    SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOD);
    
    // eso̓^Cvɐݒ
    GPIOPinTypeGPIOOutput(GPIO_PORTB_BASE, GPIO_PIN_1);
    GPIOPinTypeGPIOOutput(GPIO_PORTB_BASE, GPIO_PIN_2);
    GPIOPinTypeGPIOOutput(GPIO_PORTB_BASE, GPIO_PIN_3);
    GPIOPinTypeGPIOOutput(GPIO_PORTB_BASE, GPIO_PIN_4);
    GPIOPinTypeGPIOOutput(GPIO_PORTB_BASE, GPIO_PIN_5);
    GPIOPinTypeGPIOOutput(GPIO_PORTB_BASE, GPIO_PIN_6);
    GPIOPinTypeGPIOOutput(GPIO_PORTC_BASE, GPIO_PIN_4);
    GPIOPinTypeGPIOOutput(GPIO_PORTC_BASE, GPIO_PIN_5);
    GPIOPinTypeGPIOOutput(GPIO_PORTC_BASE, GPIO_PIN_6);
    GPIOPinTypeGPIOOutput(GPIO_PORTC_BASE, GPIO_PIN_7);
    GPIOPinTypeGPIOOutput(GPIO_PORTD_BASE, GPIO_PIN_2);
    GPIOPinTypeGPIOOutput(GPIO_PORTD_BASE, GPIO_PIN_3);
    GPIOPinTypeGPIOOutput(GPIO_PORTD_BASE, GPIO_PIN_4);
    GPIOPinTypeGPIOOutput(GPIO_PORTD_BASE, GPIO_PIN_5);
    GPIOPinTypeGPIOOutput(GPIO_PORTD_BASE, GPIO_PIN_6);
    GPIOPinTypeGPIOOutput(GPIO_PORTD_BASE, GPIO_PIN_7);
    
    while (1)
    {
        // LEDS
        GPIOPinWrite(GPIO_PORTB_BASE, GPIO_PIN_1, 0);
        GPIOPinWrite(GPIO_PORTB_BASE, GPIO_PIN_2, 0);
        GPIOPinWrite(GPIO_PORTB_BASE, GPIO_PIN_3, 0);
        GPIOPinWrite(GPIO_PORTB_BASE, GPIO_PIN_4, 0);
        GPIOPinWrite(GPIO_PORTB_BASE, GPIO_PIN_5, 0);
        GPIOPinWrite(GPIO_PORTB_BASE, GPIO_PIN_6, 0);
        GPIOPinWrite(GPIO_PORTC_BASE, GPIO_PIN_4, 0);
        GPIOPinWrite(GPIO_PORTC_BASE, GPIO_PIN_5, 0);
        GPIOPinWrite(GPIO_PORTC_BASE, GPIO_PIN_6, GPIO_PIN_6);
        GPIOPinWrite(GPIO_PORTC_BASE, GPIO_PIN_7, GPIO_PIN_7);
        GPIOPinWrite(GPIO_PORTD_BASE, GPIO_PIN_2, GPIO_PIN_2);
        GPIOPinWrite(GPIO_PORTD_BASE, GPIO_PIN_3, GPIO_PIN_3);
        GPIOPinWrite(GPIO_PORTD_BASE, GPIO_PIN_4, GPIO_PIN_4);
        GPIOPinWrite(GPIO_PORTD_BASE, GPIO_PIN_5, GPIO_PIN_5);
        GPIOPinWrite(GPIO_PORTD_BASE, GPIO_PIN_6, GPIO_PIN_6);
        GPIOPinWrite(GPIO_PORTD_BASE, GPIO_PIN_7, GPIO_PIN_7);
        
        // _𔻕
        if (character == 'A')
        {
            // uAv̕`
            switch (i)
            {
                case 0:
                    GPIOPinWrite(GPIO_PORTB_BASE, GPIO_PIN_1, GPIO_PIN_1);
                    GPIOPinWrite(GPIO_PORTD_BASE, GPIO_PIN_6, 0);
                    GPIOPinWrite(GPIO_PORTD_BASE, GPIO_PIN_7, 0);
                    break;
                case 1:
                    GPIOPinWrite(GPIO_PORTB_BASE, GPIO_PIN_2, GPIO_PIN_2);
                    GPIOPinWrite(GPIO_PORTD_BASE, GPIO_PIN_4, 0);
                    GPIOPinWrite(GPIO_PORTD_BASE, GPIO_PIN_5, 0);
                    break;
                case 2:
                    GPIOPinWrite(GPIO_PORTB_BASE, GPIO_PIN_3, GPIO_PIN_3);
                    GPIOPinWrite(GPIO_PORTD_BASE, GPIO_PIN_2, 0);
                    GPIOPinWrite(GPIO_PORTD_BASE, GPIO_PIN_3, 0);
                    GPIOPinWrite(GPIO_PORTD_BASE, GPIO_PIN_5, 0);
                    break;
                case 3:
                    GPIOPinWrite(GPIO_PORTB_BASE, GPIO_PIN_4, GPIO_PIN_4);
                    GPIOPinWrite(GPIO_PORTC_BASE, GPIO_PIN_6, 0);
                    GPIOPinWrite(GPIO_PORTC_BASE, GPIO_PIN_7, 0);
                    GPIOPinWrite(GPIO_PORTD_BASE, GPIO_PIN_5, 0);
                    break;
                case 4:
                    GPIOPinWrite(GPIO_PORTB_BASE, GPIO_PIN_5, GPIO_PIN_5);
                    GPIOPinWrite(GPIO_PORTD_BASE, GPIO_PIN_2, 0);
                    GPIOPinWrite(GPIO_PORTD_BASE, GPIO_PIN_3, 0);
                    GPIOPinWrite(GPIO_PORTD_BASE, GPIO_PIN_5, 0);
                    break;
                case 5:
                    GPIOPinWrite(GPIO_PORTB_BASE, GPIO_PIN_6, GPIO_PIN_6);
                    GPIOPinWrite(GPIO_PORTD_BASE, GPIO_PIN_4, 0);
                    GPIOPinWrite(GPIO_PORTD_BASE, GPIO_PIN_5, 0);
                    break;
                case 6:
                    GPIOPinWrite(GPIO_PORTC_BASE, GPIO_PIN_4, GPIO_PIN_4);
                    GPIOPinWrite(GPIO_PORTD_BASE, GPIO_PIN_6, 0);
                    GPIOPinWrite(GPIO_PORTD_BASE, GPIO_PIN_7, 0);
                    break;
                case 7:
                    break;
            }
        }
        else if (character == 'B')
        {
            // uBv̕`
            switch (i)
            {
                case 0:
                    break;
                case 1:
                    GPIOPinWrite(GPIO_PORTB_BASE, GPIO_PIN_2, GPIO_PIN_2);
                    GPIOPinWrite(GPIO_PORTC_BASE, GPIO_PIN_6, 0);
                    GPIOPinWrite(GPIO_PORTC_BASE, GPIO_PIN_7, 0);
                    GPIOPinWrite(GPIO_PORTD_BASE, GPIO_PIN_2, 0);
                    GPIOPinWrite(GPIO_PORTD_BASE, GPIO_PIN_3, 0);
                    GPIOPinWrite(GPIO_PORTD_BASE, GPIO_PIN_4, 0);
                    GPIOPinWrite(GPIO_PORTD_BASE, GPIO_PIN_5, 0);
                    GPIOPinWrite(GPIO_PORTD_BASE, GPIO_PIN_6, 0);
                    GPIOPinWrite(GPIO_PORTD_BASE, GPIO_PIN_7, 0);
                    break;
                case 2:
                    GPIOPinWrite(GPIO_PORTB_BASE, GPIO_PIN_3, GPIO_PIN_3);
                    GPIOPinWrite(GPIO_PORTC_BASE, GPIO_PIN_6, 0);
                    GPIOPinWrite(GPIO_PORTD_BASE, GPIO_PIN_3, 0);
                    GPIOPinWrite(GPIO_PORTD_BASE, GPIO_PIN_7, 0);
                    break;
                case 3:
                    GPIOPinWrite(GPIO_PORTB_BASE, GPIO_PIN_4, GPIO_PIN_4);
                    GPIOPinWrite(GPIO_PORTC_BASE, GPIO_PIN_6, 0);
                    GPIOPinWrite(GPIO_PORTD_BASE, GPIO_PIN_3, 0);
                    GPIOPinWrite(GPIO_PORTD_BASE, GPIO_PIN_7, 0);
                    break;
                case 4:
                    GPIOPinWrite(GPIO_PORTB_BASE, GPIO_PIN_5, GPIO_PIN_5);
                    GPIOPinWrite(GPIO_PORTC_BASE, GPIO_PIN_6, 0);
                    GPIOPinWrite(GPIO_PORTD_BASE, GPIO_PIN_3, 0);
                    GPIOPinWrite(GPIO_PORTD_BASE, GPIO_PIN_7, 0);
                    break;
                case 5:
                    GPIOPinWrite(GPIO_PORTB_BASE, GPIO_PIN_6, GPIO_PIN_6);
                    GPIOPinWrite(GPIO_PORTC_BASE, GPIO_PIN_7, 0);
                    GPIOPinWrite(GPIO_PORTD_BASE, GPIO_PIN_2, 0);
                    GPIOPinWrite(GPIO_PORTD_BASE, GPIO_PIN_4, 0);
                    GPIOPinWrite(GPIO_PORTD_BASE, GPIO_PIN_5, 0);
                    GPIOPinWrite(GPIO_PORTD_BASE, GPIO_PIN_6, 0);
                    break;
                case 6:
                    break;
                case 7:
                    break;
              }
        }
        // _Ci~bN_p̑҂ԁi1msj
        OSTimeDly(OS_TICKS_PER_SEC / 1000);
        i++;
        if (i > 8)
        {
            i = 0;
        }
    }
}

/********************************************************************************************
    FatFs^XN
********************************************************************************************/
void Task_FatFs(void *pdata)
{
    static FATFS Work;      // _hCũ[NGA
    static FIL File_Object; // t@CIuWFNg
    char Read_Buffer[20];   // ǂݍ݃obt@
    static FRESULT Result;  // FatFs֐̌ʃR[h
    WORD Read_Byte;         // ǂݍ݃JE^
    
    // OLEDɃbZ[W\
    RIT128x96x4StringDraw("Read text:", 0, 80, 10);
    // OLEDOFF
    RIT128x96x4DisplayOff();
    // OLED
    RIT128x96x4Disable();

    // hCu0Ƀ[NGA^
    f_mount(0, &Work);
    
    // hCu0Read.txtǂݍݐpŊJ
    Result = f_open(&File_Object, "0:Read.txt", FA_OPEN_EXISTING | FA_READ);
    
    // G[`FbN
    if (Result != FR_OK)
    {
        // OLEDL
        RIT128x96x4Enable(1000000);
        // OLEDON
        RIT128x96x4DisplayOn();
        // OLEDɃbZ[W\
        RIT128x96x4StringDraw("Read file open error", 0, 88, 15);
    }
    else
    {
        // t@C當f[^ǂݍ
        Result = f_read(&File_Object, Read_Buffer, sizeof(Read_Buffer), &Read_Byte);
        // OLEDL
        RIT128x96x4Enable(1000000);
        // OLEDON
        RIT128x96x4DisplayOn();
        // G[`FbN
        if (Result != FR_OK)
        {
            // OLEDɃbZ[W\
            RIT128x96x4StringDraw("Read error", 0, 88, 15);
        }
        else
        {
            // ǂݍ񂾕OLEDɕ\
            RIT128x96x4StringDraw(Read_Buffer, 0, 88, 15);
        }
    }
    // t@C
    f_close(&File_Object);
    
    // [NGÅJ
    f_mount(0, 0);

    while (1)
    {
        // ԑ҂
        OSTimeDly(OS_TICKS_PER_SEC / 100);
    }
}

/********************************************************************************************
    HTTP^XN
********************************************************************************************/
void Task_HTTP(void *pdata)
{
    // HTTPX|X`
    unsigned char Response_Header[] = 
    {
        "HTTP/1.0 200 OK\r\n"
        "Connection: close\r\n"
        "Content-Type: text/html\r\n"
        "\r\n"
    };
    
    // HTTPX|X`(G[)
    unsigned char Error_Header[] = 
    {
        "HTTP/1.0 500\r\n"
    };

    // \weby[Whtml\[X
    unsigned char page[] =
    {
        "<html>\r\n"
        "<head>\r\n"
        "</head>\r\n"
        "<body>\r\n"
        "HELLO WORLD\r\n"
        "</body>\r\n"
        "</html>\r\n"
    };
    
    static FATFS Work;      // _hCũ[NGA
    static FIL File_Object; // t@CIuWFNg
    uint8 Read_Buffer[500];   // ǂݍ݃obt@
    static FRESULT Result;  // FatFs֐̌ʃR[h
    WORD Read_Byte;         // ǂݍ݃JE^
    int i, j;               // t@CpXpJE^
    char File_path[40];     // t@CpXi[p
    char Order[20];         // I/Oߊi[p
    int DotMatrix = 0;      // hbg}gNXON/OFF؂ւp
    unsigned long ulPeriod; // PWMݒp
    unsigned long data;     // A/Dϊli[p
    double temp;            // A/DZp
    int Temperature = 0;    // xf[^
    uint8 Temp[5] = {0};    // xf[^Mp
    
    unsigned char Connection = 0;       // uEUƂ̐ڑ
    unsigned char Receive_data[400];    // Mobt@
    int addrlen;                        // NCAg̃AhX
    SOCKET srcSocket;                   // \Pbg
    struct sockaddr servaddr, cliaddr;  // \PbgAhX\
    
    // gp|[g̐錾@LEDpɃ|[gBCgpASWpɃ|[gFgp
    SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOB);
    SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOC);
    SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOE);

    // PWM@\̎gp錾
    SysCtlPeripheralEnable(SYSCTL_PERIPH_PWM);
    
    // ADC0̎gp錾
    SysCtlPeripheralEnable(SYSCTL_PERIPH_ADC0);
    
    // PB3o̓^Cvɐݒ
    GPIOPinTypeGPIOOutput(GPIO_PORTB_BASE, GPIO_PIN_3);

    // PE0`3܂łvAbv̓^Cvɐݒ
    GPIODirModeSet(GPIO_PORTE_BASE, GPIO_PIN_0, GPIO_DIR_MODE_IN);
    GPIOPadConfigSet(GPIO_PORTE_BASE, GPIO_PIN_0, GPIO_STRENGTH_2MA, GPIO_PIN_TYPE_STD_WPU);
    GPIODirModeSet(GPIO_PORTE_BASE, GPIO_PIN_1, GPIO_DIR_MODE_IN);
    GPIOPadConfigSet(GPIO_PORTE_BASE, GPIO_PIN_1, GPIO_STRENGTH_2MA, GPIO_PIN_TYPE_STD_WPU);
    GPIODirModeSet(GPIO_PORTE_BASE, GPIO_PIN_2, GPIO_DIR_MODE_IN);
    GPIOPadConfigSet(GPIO_PORTE_BASE, GPIO_PIN_2, GPIO_STRENGTH_2MA, GPIO_PIN_TYPE_STD_WPU);
    GPIODirModeSet(GPIO_PORTE_BASE, GPIO_PIN_3, GPIO_DIR_MODE_IN);
    GPIOPadConfigSet(GPIO_PORTE_BASE, GPIO_PIN_3, GPIO_STRENGTH_2MA, GPIO_PIN_TYPE_STD_WPU);
    
    // PWM@\Ŏg|[g̎w
    GPIOPinTypePWM(GPIO_PORTB_BASE, GPIO_PIN_0);
    // PWM̎w 10[ms]
    ulPeriod = SysCtlClockGet() / 4 / 100;
    // PWMeݒ
    PWMGenConfigure(PWM_BASE, PWM_GEN_1, PWM_GEN_MODE_UP_DOWN | PWM_GEN_MODE_NO_SYNC);
    // PWM̃NbNݒ
    SysCtlPWMClockSet(SYSCTL_PWMDIV_4);
    // PWM̎ݒ
    PWMGenPeriodSet(PWM_BASE, PWM_GEN_1, ulPeriod);
    // PWM̃f[eB[̎w
    PWMOutputState(PWM_BASE, PWM_OUT_2_BIT, true);
    PWMPulseWidthSet(PWM_BASE, PWM_OUT_2, ulPeriod * 15 / 100);
    PWMGenEnable(PWM_BASE, PWM_GEN_1);
    
    // ADC0̊eݒ    
    ADCSequenceConfigure(ADC0_BASE, 3, ADC_TRIGGER_PROCESSOR, 0);
    ADCSequenceStepConfigure(ADC0_BASE, 3, 0, ADC_CTL_CH0 | ADC_CTL_IE | ADC_CTL_END);
    ADCSequenceEnable(ADC0_BASE, 3);
    
    // T[o(}CR)IPAhXу|[gԍ̐ݒ
    servaddr.sin_family = 0;
    servaddr.sin_addr[0] = NetPort[0].My_Ip[0];
    servaddr.sin_addr[1] = NetPort[0].My_Ip[1];
    servaddr.sin_addr[2] = NetPort[0].My_Ip[2];
    servaddr.sin_addr[3] = NetPort[0].My_Ip[3];
    servaddr.sin_port = 80;
    
    // \Pbg̐
    srcSocket = *socket(PF_INET, SOCK_STREAM, TCP_PROTOCOL);
    
    // \Pbg̃oCh
    bind((SOCKET *)&srcSocket, (struct sockaddr*)&servaddr, sizeof(servaddr));
    
    // ڑ̋
    listen((SOCKET *)&srcSocket, 4);

    while (1)
    {
        // ڑt
        Connection = accept((SOCKET *)&srcSocket, (struct sockaddr *)&cliaddr, &addrlen);
        if (Connection != 0xff)
        {
            OSTimeDly(20);
            // pPbgM
            recv(Connection, Receive_data, sizeof(Receive_data), 0);
            // HTTPNGXg̃`FbN
            if (Receive_data[0] == 'G')
            {                
                // pX`FbN
                if (Receive_data[5] != ' ')
                {
                    // t@CpX
                    memset(File_path, 0, sizeof(File_path));
                    // t@CpX̒o
                    i = 5;
                    j = 2;
                    while (Receive_data[i] != ' ')
                    {
                        File_path[j] = Receive_data[i];
                        i++;
                        j++;
                    }
                    File_path[0] = '0';
                    File_path[1] = ':';
                    File_path[j] = '\0';
                    
                    // OLEDOFF
                    RIT128x96x4DisplayOff();
                    // OLED
                    RIT128x96x4Disable();
                    // hCu0Ƀ[NGA^
                    f_mount(0, &Work);
                    // w肳ꂽt@CJ
                    Result = f_open(&File_Object, File_path, FA_OPEN_EXISTING | FA_READ);
                    // G[`FbN
                    if(Result == FR_OK)
                    {
                        // HTTPX|X𑗐M
                        send(Connection, Response_Header, sizeof(Response_Header) - 1, 0);
                        // htm𑗐M
                        do
                        {
                            // obt@
                            memset(Read_Buffer, 0, sizeof(Read_Buffer));
                            // htmǂݍ
                            f_read(&File_Object, Read_Buffer, sizeof(Read_Buffer), &Read_Byte);
                            // html\[X𑗐M
                            send(Connection, Read_Buffer, sizeof(Read_Buffer), 0 );
                        } while (Read_Byte >= sizeof(Read_Buffer));
                        // t@C
                        f_close(&File_Object);
                    }
                    // G[
                    else
                    {
                        // HTTPX|X(G[)𑗐M
                        send(Connection, Error_Header, sizeof(Error_Header) - 1, 0);
                    }
                    // [NGÅJ
                    f_mount(0, 0);
                    // OLEDL
                    RIT128x96x4Enable(1000000);
                    // OLEDON
                    RIT128x96x4DisplayOn();
                }
                // t@Cw̏ꍇ
                else
                {
                    // HTTPX|X𑗐M
                    send(Connection, Response_Header, sizeof(Response_Header) - 1, 0);
                    // html\[X𑗐M
                    send(Connection, page, sizeof(page), 0 );
                }
            }
            else if (Receive_data[0] == 'P')
            {
                // uEU̖߂𒊏o
                i = 6;
                j = 0;
            	while(Receive_data[i] != ' ')
                {
                    i++;
                }
                j = i;
                while(Receive_data[j] != '/')
                {
                    j--;
                }
                i = j + 1;
                j = 0;
                while(Receive_data[i] != ' ')
                {
                    Order[j] = Receive_data[i];
                    i++;
                    j++;
                }
                Order[j] = '\0';
            	
                // STEP 10-1@߂"toggle_led"
                if (strcmp(Order, "toggle_led") == 0)
                {
                    // hbg}gNXON/OFF[h؂ւ
                    DotMatrix = ~DotMatrix;
                    // [h
                    if (DotMatrix == 0)
                    {
                        // ^XNĊJ
                        OSTaskResume(TASK_DotMatrix_PRIO);
                    }
                    else
                    {
                        // ^XN~
                        OSTaskSuspend(TASK_DotMatrix_PRIO);
                        // LEDS
                        GPIOPinWrite(GPIO_PORTB_BASE, GPIO_PIN_1, 0);
                        GPIOPinWrite(GPIO_PORTB_BASE, GPIO_PIN_2, 0);
                        GPIOPinWrite(GPIO_PORTB_BASE, GPIO_PIN_3, 0);
                        GPIOPinWrite(GPIO_PORTB_BASE, GPIO_PIN_4, 0);
                        GPIOPinWrite(GPIO_PORTB_BASE, GPIO_PIN_5, 0);
                        GPIOPinWrite(GPIO_PORTB_BASE, GPIO_PIN_6, 0);
                        GPIOPinWrite(GPIO_PORTC_BASE, GPIO_PIN_4, 0);
                        GPIOPinWrite(GPIO_PORTC_BASE, GPIO_PIN_5, 0);
                        GPIOPinWrite(GPIO_PORTC_BASE, GPIO_PIN_6, GPIO_PIN_6);
                        GPIOPinWrite(GPIO_PORTC_BASE, GPIO_PIN_7, GPIO_PIN_7);
                        GPIOPinWrite(GPIO_PORTD_BASE, GPIO_PIN_2, GPIO_PIN_2);
                        GPIOPinWrite(GPIO_PORTD_BASE, GPIO_PIN_3, GPIO_PIN_3);
                        GPIOPinWrite(GPIO_PORTD_BASE, GPIO_PIN_4, GPIO_PIN_4);
                        GPIOPinWrite(GPIO_PORTD_BASE, GPIO_PIN_5, GPIO_PIN_5);
                        GPIOPinWrite(GPIO_PORTD_BASE, GPIO_PIN_6, GPIO_PIN_6);
                        GPIOPinWrite(GPIO_PORTD_BASE, GPIO_PIN_7, GPIO_PIN_7);
                    }
                }
                // STEP 10-2@߂"character_change"
                else if (strcmp(Order, "character_change") == 0)
                {
                    if (character == 'A')
                    {
                        character = 'B';
                    }
                    else if (character == 'B')
                    {
                        character = 'A';
                    }
                }
                // STEP 11@߂"get_sw"
                else if (strcmp(Order, "get_sw") == 0)
                {
                    // HTTPX|X𑗐M
                    send(Connection, Response_Header, sizeof(Response_Header) - 1, 0);
                    // SW3Ă邩
    	            if (GPIOPinRead(GPIO_PORTE_BASE, GPIO_PIN_0) == 0)
    	            {
    	                // bZ[W𑗐M
    	                send(Connection, "PUSH SW3", sizeof("PUSH SW3") - 1, 0);
                    }
                    // SW4Ă邩
                    else if (GPIOPinRead(GPIO_PORTE_BASE, GPIO_PIN_1) == 0)
                    {
    	                // bZ[W𑗐M
    	                send(Connection, "PUSH SW4", sizeof("PUSH SW4") - 1, 0);
                    }
                    // SW5Ă邩
                    else if (GPIOPinRead(GPIO_PORTE_BASE, GPIO_PIN_2) == 0)
                    {
    	                // bZ[W𑗐M
    	                send(Connection, "PUSH SW5", sizeof("PUSH SW5") - 1, 0);
                    }
                    // SW6Ă邩
                    else if (GPIOPinRead(GPIO_PORTE_BASE, GPIO_PIN_3) == 0)
                    {
    	                // bZ[W𑗐M
    	                send(Connection, "PUSH SW6", sizeof("PUSH SW6") - 1, 0);
                    }
                }
                // STEP 12@߂"servo_left"
                else if (strcmp(Order, "servo_left") == 0)
                {
                    PWMPulseWidthSet(PWM_BASE, PWM_OUT_2, ulPeriod * 23 / 100);
                }
                // STEP 12@߂"servo_center"
                else if (strcmp(Order, "servo_center") == 0)
                {
                    PWMPulseWidthSet(PWM_BASE, PWM_OUT_2, ulPeriod * 15 / 100);
                }
                // STEP 12@߂"servo_right"
                else if (strcmp(Order, "servo_right") == 0)
                {
                    PWMPulseWidthSet(PWM_BASE, PWM_OUT_2, ulPeriod * 7 / 100);
                }
                // STEP 13@߂"get_temp"
                else if (strcmp(Order, "get_temp") == 0)
                {
                    // A/DϊJn
                    ADCProcessorTrigger(ADC0_BASE, 3);
                    // A/Dϊl̎擾
                    ADCSequenceDataGet(ADC0_BASE, 3, &data);
                    // A/Dlx֊Z LM61p
                    temp = 2.93255132;
                    temp *= data;
                    temp -= 600;
                    temp /= 10;
                    temp *= 10;
                    Temperature = (int)temp;
                    // 擾x𕶎ɕϊ
                    Temp[0] = (Temperature / 100) + 0x30;
                    Temp[1] = ((Temperature % 100) / 10) + 0x30;
                    Temp[2] = '.';
                    Temp[3] = ((Temperature % 100) % 10) + 0x30;
                    Temp[4] = '\0';
                    // HTTPX|X𑗐M
                    send(Connection, Response_Header, sizeof(Response_Header) - 1, 0);
                    // 擾x𑗐M
                    send(Connection, Temp, sizeof(Temp) - 1, 0);
                }
            }
            // Mf[^NA
            memset(Receive_data, 0, 400);
            OSTimeDly(20);
            // ڑI
            close(Connection);
        }
    }
}

/********************************************************************************************
    OLED\^XN
********************************************************************************************/
void Task_OLED(void *pdata)
{
    int i, j;               // ėpJE^
    int IP[4] = MY_IP_1ID;  // IPAhX
    char IP_Address[17];    // IPAhX\pz
    
    // IPAhX𕶎ɕϊ
    j = 0;
    for (i=0;i<4;i++)
    {
        IP_Address[j++] = (IP[i] / 100) + 0x30;
        IP_Address[j++] = (IP[i] % 100 / 10) + 0x30;
        IP_Address[j++] = (IP[i] % 100 % 10) + 0x30;
        IP_Address[j++] = '.';
    }
    IP_Address[16] = '\0';
    
    // OLED̏
    RIT128x96x4Init(1000000);
    
    // OLEDɕIPAhX\
    RIT128x96x4StringDraw("HTTP SERVER", 31, 0, 15);
    RIT128x96x4StringDraw("IP ADDRESS:", 0, 16, 10);
    RIT128x96x4StringDraw(IP_Address, 32, 24, 15);

    while (1)
    {
        // ԑ҂
        OSTimeDly(OS_TICKS_PER_SEC / 100);
    }
}

/********************************************************************************************
    LED_Ń^XN
********************************************************************************************/
void Task_LED(void *pdata)
{
    // LED1̃ytFݒ
    SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOF);
    GPIOPinTypeGPIOOutput(GPIO_PORTF_BASE, GPIO_PIN_0);

    while (1)
    {
        // StatusLED1bœ_
        GPIOPinWrite(GPIO_PORTF_BASE, GPIO_PIN_0, GPIO_PIN_0);
        OSTimeDly(OS_TICKS_PER_SEC / 2);
        GPIOPinWrite(GPIO_PORTF_BASE, GPIO_PIN_0, 0);
        OSTimeDly(OS_TICKS_PER_SEC / 2);
    }
}

/********************************************************************************************
    X^[gAbv^XN
********************************************************************************************/
void Task_Startup (void  *pdata)
{ 
    // ^[Qbg
    targetInit();
    
    // [U[^XN쐬
    OSTaskCreate(Task_LED, (void *)0, &TASK_LED_stack[TASK_LED_STACK - 1], TASK_LED_PRIO);
    OSTaskCreate(Task_OLED, (void *)0, &TASK_OLED_stack[TASK_OLED_STACK - 1], TASK_OLED_PRIO);
    OSTaskCreate(Task_HTTP, (void *)0, &TASK_HTTP_stack[TASK_HTTP_STACK - 1], TASK_HTTP_PRIO);
    OSTaskCreate(Task_FatFs, (void *)0, &TASK_FatFs_stack[TASK_FatFs_STACK - 1], TASK_FatFs_PRIO);
    OSTaskCreate(Task_DotMatrix, (void *)0, &TASK_DotMatrix_stack[TASK_DotMatrix_STACK - 1], TASK_DotMatrix_PRIO);

    while (1)
    {
        // ԑ҂
        OSTimeDly(OS_TICKS_PER_SEC / 100);
    }
}

/********************************************************************************************
    C
********************************************************************************************/
void main (void)
{
    // OS
    OSInit();
    
    // X^[gAbv^XN쐬
    OSTaskCreate(Task_Startup, (void *)0, &TASK_Startup_stack[TASK_Startup_STACK - 1], TASK_START_PRIO);

    // OSX^[g
    OSStart();
}

/********************************************************************************************
    END FILE 
********************************************************************************************/
