#ifdef UDP_GLOBALS
	#define UDP_EXT
#else
	#define UDP_EXT extern 
#endif 

struct udp_dhead
{
	uint8 rev; 
	uint8 NextProtocal;
	uint16 TotalLen;
	uint8 SourceIp[4];
	uint8 DestId[4];
};

struct udp_data
{
	uint16 SourcePort;
	uint16 DestPort;
	uint16 length;
	uint16 Crc;
};

typedef struct
{
	struct udp_dhead UdpDHead;
	struct udp_data Udp;
}udp_send;

typedef struct
{
	uint8 DestIp[4];
	uint16 SourcePort;
	uint16 DestPort;
	uint16 length;
	uint8 *data_ptr;
}udp_socket;

UDP_EXT uint8 *Udp_Process(uint8 EX_RAM *Udp_Rec) USE_XDATA keilreentrant;
UDP_EXT void Udp_Send_Packed() USE_XDATA keilreentrant;

